/*
 * $Id: ExportAction.java,v 1.8 2005/09/24 17:32:40 ema_sab Exp $ Created on Jun 4, 2004
 */
package it.uniroma3.plasm.actionset;
import it.uniroma3.plasm.core.Plasm;

import java.io.IOException;
import java.util.logging.Logger;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
/**
 * This actions exports the selected object into a VRML script (by now
 * only VRML, next mod would be other formats...)
 * 
 * @author giupo
 * @version $Id: ExportAction.java,v 1.8 2005/09/24 17:32:40 ema_sab Exp $
 */
public class ExportAction implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;
	private ISelection selection;

	/**
	 * default logger
	 */
	private Logger log;
	/**
	 * default constructor
	 */
	public ExportAction() {
		log = Logger.getLogger(this.getClass().getName());
	}
	/**
	 * This action exports the selected obj
	 * 
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		/** log.warning(""+String.valueOf(SWT.CTRL | 'e')); */

		Plasm plasm = Plasm.getInstance();
		if (!plasm.isActive()) {
			MessageDialog.openError(window.getShell(), "Error",
					"Plasm is Not Active");
			return;
		}
		String initialValue;
		if (selection != null && selection instanceof ITextSelection) {
			ITextSelection textSelection = (ITextSelection) selection;
			initialValue = textSelection.getText();
			initialValue = initialValue.trim();
			if ("".equals(initialValue)) {
				initialValue = "last_value";
			}
		} else {
			initialValue = "last_value";
		}
		InputDialog dialog = new InputDialog(window.getShell(), "Plasm Export",
				"Object to be exported", initialValue, null);
		dialog.open();
		if (dialog.getReturnCode() == InputDialog.OK) {
			FileDialog fileDialog = new FileDialog(window.getShell(), SWT.SAVE);
			fileDialog.setFileName(dialog.getValue() + ".wrl");
			String fileName = fileDialog.open();
			
			//Many thanks to Bill Gates!! (or who, in his place, made that mess)
			if (fileName != null) {
				fileName = fileName.replace('\\','/');
				try {
					plasm.eval("vrml : " + dialog.getValue() + ": '" + fileName
							+ "'");

				} catch (IOException e) {
					MessageDialog.openError(window.getShell(), "Error",
							"Export Error\n" + e.toString());
				}
			}
		}
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}
}