package it.uniroma3.plasm.actionset;

import it.uniroma3.plasm.core.Plasm;

import java.util.logging.Logger;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
/**
 * This class provides the basic start function for the plasm Process
 * 
 * @author giupo
 * @version $Id: StartPlasm.java,v 1.5 2004/06/15 08:23:17 giupo Exp $
 * @see IWorkbenchWindowActionDelegate
 */
public class StartPlasm implements IWorkbenchWindowActionDelegate {

	private IWorkbenchWindow window;

	/**
	 * default logger
	 */

	private Logger log;

	/**
	 * default constructor
	 */
	public StartPlasm() {
		log = Logger.getLogger(this.getClass().getName());

	}

	/**
	 * This action Starts and runs the Plasm Process
	 * 
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		/**
		 * log.warning(""+String.valueOf(SWT.CTRL | 'e'));
		 * 
		 * log.warning(""+String.valueOf(SWT.CTRL | SWT.SHIFT | 'x'));
		 */
		Plasm plasm = Plasm.getInstance();

		try {
			plasm.open();
		} catch (Throwable e) {
			MessageDialog.openError(window.getShell(), "Error", e.toString());
			log.warning(e.getMessage());
			e.printStackTrace();
		}
	}

	/**
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

	/**
	 * 
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}

	/**
	 * 
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}
}