package it.uniroma3.plasm.editors;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.DefaultPartitioner;
import org.eclipse.ui.editors.text.FileDocumentProvider;

/**
 * A standard document manager. This document provider is associated with
 * PLaSM editor and creates the PLaSM partitioner.
 * 
 * @author EcT(o)PLaSM Group 
 */
public class PlasmDocumentProvider extends FileDocumentProvider {

	/**
	 * Default constructor for document provider it associates to the current
	 * document a PLaSM partition scanner
	 */
	protected IDocument createDocument(Object element) throws CoreException {
		IDocument document = super.createDocument(element);
		if (document != null) {
			IDocumentPartitioner partitioner = new DefaultPartitioner(
					new PlasmPartitionScanner(),
					PlasmPartitionScanner.PSM_PARTITION_TYPES);
			partitioner.connect(document);
			document.setDocumentPartitioner(partitioner);
		}
		return document;
	}
}