package it.uniroma3.plasm.actions;
import java.util.logging.Logger;

import org.eclipse.jface.text.IDocument;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.texteditor.ITextEditor;
/**
 * This action evaluates all the buffer
 * 
 * @author giupo
 * @version $Id: EvaluateAllBuffer.java,v 1.5 2004/06/15 08:23:17 giupo Exp $
 * @see IWorkbenchWindowActionDelegate
 */
public class EvaluateAllBuffer extends EvaluateAction {
	private Logger log;
	/**
	 *  
	 */
	public EvaluateAllBuffer() {
		super();
		log = Logger.getLogger(this.getClass().getName());
	}

	public void evaluate() {
		IEditorPart editorPart = window.getActivePage().getActiveEditor();
		if (editorPart instanceof ITextEditor) {
			ITextEditor editor = (ITextEditor) editorPart;
			IDocument doc = editor.getDocumentProvider().getDocument(
					editor.getEditorInput());
			String cmd = doc.get();
			if (cmd.length() != 0) {
				try {
					plasm.eval(cmd);
				} catch (java.io.IOException e) {
					log.warning(e.getMessage());
				}
			} else {
				log.info("Selection empty, discarding..");
			}
		}
	}
}