package it.uniroma3.plasm.actionset;
import it.uniroma3.plasm.core.Plasm;

import java.util.logging.Logger;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

/**
 * Self Explained
 * 
 * @author giupo
 * @version $Id: StopPlasm.java,v 1.2 2004/06/09 14:35:17 giupo Exp $
 * @see IWorkbenchWindowActionDelegate
 * @see StartPlasm
 */
public class StopPlasm implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;
	/**
	 * default logger
	 */
	private Logger log;
	/**
	 * Default Constructor
	 */
	public StopPlasm() {
		log = Logger.getLogger(this.getClass().getName());
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		Plasm plasm = Plasm.getInstance();
		try {
			if (plasm.isActive()) {
				plasm.close();
			} /*
			   * else { MessageDialog.openInformation(window.getShell(), "Info",
			   * "Plasm isn't active!"); }
			   */
		} catch (Throwable e) {
			MessageDialog.openError(window.getShell(), "Error", e.toString());
			log.warning(e.getMessage());
		}
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}
	/**
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}
}