package it.uniroma3.plasm.editors;

import it.uniroma3.plasm.actions.EvaluateAllBuffer;
import it.uniroma3.plasm.actions.EvaluateSelection;
import it.uniroma3.plasm.editors.util.PlasmColorProvider;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.editors.text.TextEditor;

public class PlasmEditor extends TextEditor implements ISelectionListener{
	private EvaluateSelection evaluateSelection;
	private EvaluateAllBuffer evaluateAllBuffer;
	private PlasmColorProvider colorManager;
	public void createPartControl(Composite parent){
		super.createPartControl(parent);
		makeActions();
		getEditorSite().getActionBars().setGlobalActionHandler(
				"it.uniroma3.plasm.actionset.EvaluateSelection",
				evaluateSelection);
		getEditorSite().getActionBars().setGlobalActionHandler(
				"it.uniroma3.plasm.actionset.EvaluateBuffer",
				evaluateAllBuffer);
	}
	private void makeActions() {
		evaluateSelection=new EvaluateSelection();
		evaluateSelection.setWorkbenchWindow(
			this.getEditorSite().getWorkbenchWindow());
		getSite().getWorkbenchWindow().getSelectionService().addSelectionListener(this);
		evaluateAllBuffer=new EvaluateAllBuffer();
		evaluateAllBuffer.setWorkbenchWindow(
			this.getEditorSite().getWorkbenchWindow());

	}
	public PlasmEditor() {
		super();
		colorManager = new PlasmColorProvider();
		setSourceViewerConfiguration(new PlasmSourceViewerConfiguration(
				colorManager));
		setDocumentProvider(new PlasmDocumentProvider());
		
	}
	
	public void dispose() {
		colorManager.dispose();
		super.dispose();
		getSite().getWorkbenchWindow().getSelectionService().removeSelectionListener(this);
	}
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.evaluateSelection.setSelection(selection);
	}
	
}