package it.uniroma3.plasm.editors.util;

import org.eclipse.jface.text.rules.IWhitespaceDetector;

/**
 * This Detector object checks if a character can be considered a withe space.
 * Requested by PlasmCodeScanner for syntax highlighting.
 * 
 * @author EcT(o)PLaSM Group
 */
public class PlasmWhitespaceDetector implements IWhitespaceDetector {

	/**
	 * Requested by IWhitespaceDetector interface, simply check if the
	 * given parameter c is a white space, a tab, a new line or a carriage
	 * return character
	 * 
	 * @param c the character to examine
	 * @return true if c is ' ', '\t', '\n', '\r', false otherwise.
	 */
	public boolean isWhitespace(char c) {
		return (c == ' ' || c == '\t' || c == '\n' || c == '\r');
	}
}